(HDU - 1159) Common Subsequence(DP)

34 篇文章 0 订阅

A subsequence of a given sequence is the given sequence with some elements (possible none) left out. Given a sequence X = <x1, x2, ..., xm> another sequence Z = <z1, z2, ..., zk> is a subsequence of X if there exists a strictly increasing sequence <i1, i2, ..., ik> of indices of X such that for all j = 1,2,…,k, xij = zj. For example, Z = <a, b, f, c> is a subsequence of X = <a, b, c, f, b, c> with index sequence <1, 2, 4, 6>. Given two sequences X and Y the problem is to find the length of the maximum-length common subsequence of X and Y.
The program input is from a text file. Each data set in the file contains two strings representing the given sequences. The sequences are separated by any number of white spaces. The input data are correct. For each set of data the program prints on the standard output the length of the maximum-length common subsequence from the beginning of a separate line.
Input
abcfbc abfcab
programming contest
abcd mnp

Output
4
2
0

题意:给定两个字符串,求最长公共子序列

分析:两个字符串中的两个字符有两种情况:相等或不等
状态转移方程
dp[i+1][j+1]=dp[i][j]+1,相等时
dp[i+1][j+1]=max(dp[i+1][j],dp[i][j+1]),不等时

1.二重循环实现
这里写图片描述

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define mem(a,n) memset(a,n,sizeof(a))
const int N=505;
int dp[N][N];
char str1[N],str2[N];
void solve(int n,int m)
{
    mem(dp,0);
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
        {
            if(str1[i]==str2[j])
                dp[i+1][j+1]=dp[i][j]+1;
            else dp[i+1][j+1]=max(dp[i][j+1],dp[i+1][j]);
        }
    printf("%d\n",dp[n][m]);
}
int main()
{
    while(~scanf("%s%s",str1,str2))
    {
        int len1=strlen(str1);
        int len2=strlen(str2);
        solve(len1,len2);
    }
    return 0;
}

2.递归实现
这里写图片描述
这里实现时必须要采取记忆化,就是储存在数组中,否则TLE

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define mem(a,n) memset(a,n,sizeof(a))
const int N=505;
int dp[N][N];
int len1,len2;
char str1[N],str2[N];
int dfs(int n,int m)
{
    if(n==len1||m==len2)
        return 0;
    int& ret=dp[n][m];
    if(ret!=-1) return ret;
    if(str1[n]==str2[m])
        return ret=dfs(n+1,m+1)+1;
    else return ret=max(dfs(n+1,m),dfs(n,m+1));
}
int main()
{
    while(~scanf("%s%s",str1,str2))
    {
        mem(dp,-1);
        len1=strlen(str1);
        len2=strlen(str2);
        printf("%d\n",dfs(0,0));
    }
    return 0;
}

从以上两种实现的截图来看,递归因为有许多重复调用,会消耗不少时间,虽然可以把dp置为-1表示没有访问过(就是还没有最大长度),这样能够避免TLE,但是其时间还是会比循环的时候多。

因此在时间卡的比较紧的时候最好用循环实现。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值